Index: tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/importer/factiva/factivamailLoader.groovy
===================================================================
--- tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/importer/factiva/factivamailLoader.groovy	(revision 3054)
+++ tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/importer/factiva/factivamailLoader.groovy	(revision 3055)
@@ -104,7 +104,8 @@
 boolean annotationSuccess = false;
 if (annotate) {
 	println "-- ANNOTATE - Running NLP tools"
-	def engine = Toolbox.getEngineManager(EngineType.ANNOTATION).getEngine("TreeTagger")
+	String engineName = project.getImportParameters().node("annotate").get("engine", "TreeTagger")
+	def engine = Toolbox.getEngineManager(EngineType.ANNOTATION).getEngine(engineName)
 	if (engine.processDirectory(txmDir, binDir, ["lang":model])) {
 		annotationSuccess = true;
 	}
Index: tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/importer/transcriber/transcriberLoader.groovy
===================================================================
--- tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/importer/transcriber/transcriberLoader.groovy	(revision 3054)
+++ tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/importer/transcriber/transcriberLoader.groovy	(revision 3055)
@@ -191,7 +191,8 @@
 		boolean annotationSuccess = false;
 		if (annotate) {
 			println "-- ANNOTATE - Running NLP tools"
-			def engine = Toolbox.getEngineManager(EngineType.ANNOTATION).getEngine("TreeTagger")
+			String engineName = project.getImportParameters().node("annotate").get("engine", "TreeTagger")
+	def engine = Toolbox.getEngineManager(EngineType.ANNOTATION).getEngine(engineName)
 			if (engine.processDirectory(txmDir, binDir, ["lang":model])) {
 				annotationSuccess = true;
 				
Index: tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/importer/txt/txtLoader.groovy
===================================================================
--- tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/importer/txt/txtLoader.groovy	(revision 3054)
+++ tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/importer/txt/txtLoader.groovy	(revision 3055)
@@ -133,7 +133,8 @@
 boolean annotationSuccess = true;
 if (annotate) {
 	println "-- ANNOTATE - Running NLP tools"
-	def engine = Toolbox.getEngineManager(EngineType.ANNOTATION).getEngine("TreeTagger")
+	String engineName = project.getImportParameters().node("annotate").get("engine", "TreeTagger")
+	def engine = Toolbox.getEngineManager(EngineType.ANNOTATION).getEngine(engineName)
 	if (engine.processDirectory(txmDir, binDir, ["lang":model])) {
 		annotationSuccess = true;
 		if (project.getCleanAfterBuild()) {
Index: tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/importer/alceste/alcesteLoader.groovy
===================================================================
--- tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/importer/alceste/alcesteLoader.groovy	(revision 3054)
+++ tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/importer/alceste/alcesteLoader.groovy	(revision 3055)
@@ -90,7 +90,8 @@
 
 if (annotate) {
 	println "-- ANNOTATE - Running NLP tools"
-	def engine = Toolbox.getEngineManager(EngineType.ANNOTATION).getEngine("TreeTagger")
+	String engineName = project.getImportParameters().node("annotate").get("engine", "TreeTagger")
+	def engine = Toolbox.getEngineManager(EngineType.ANNOTATION).getEngine(engineName)
 	if (engine.processDirectory(txmDir, binDir, ["lang":model])) {
 		annotationSuccess = true;
 	}
Index: tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/importer/alceste/importer.groovy
===================================================================
--- tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/importer/alceste/importer.groovy	(revision 3054)
+++ tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/importer/alceste/importer.groovy	(revision 3055)
@@ -47,6 +47,7 @@
 import java.io.PrintStream;
 import java.net.URL;
 
+import org.txm.core.engines*
 import org.txm.scripts.filters.CutHeader.*;
 import org.txm.scripts.filters.Tokeniser.*;
 import org.txm.scripts.filters.FusionHeader.*;
@@ -108,9 +109,17 @@
 			cpb.tick()
 			File resultfile = new File(tokenizeDir, f.getName());
 			try {
-				def builder = new SimpleTokenizerXml(f, resultfile, lang);
-				builder.setStartTag("text")
-				if (!builder.process()) {
+				def tokenizer = new SimpleTokenizerXml(f, resultfile, lang);
+				if (project.getAnnotate()) { // an annotation will be done, does the annotation engine needs another tokenizer ?
+					String engineName = project.getImportParameters().node("annotate").get("engine", "TreeTagger")
+					def engine = Toolbox.getEngineManager(EngineType.ANNOTATION).getEngine(engineName)
+					def stringTokenizer = engine.getStringTokenizer(lang)
+					if (stringTokenizer != null) {
+						tokenizer.setStringTokenizer(stringTokenizer)
+					}
+				}
+				tokenizer.setStartTag("text")
+				if (!tokenizer.process()) {
 					println "Failed to tokenize: "+f;
 					resultfile.delete();
 				}
Index: tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/importer/hyperbase/hyperbaseLoader.groovy
===================================================================
--- tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/importer/hyperbase/hyperbaseLoader.groovy	(revision 3054)
+++ tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/importer/hyperbase/hyperbaseLoader.groovy	(revision 3055)
@@ -78,7 +78,7 @@
 if (MONITOR != null && MONITOR.isCanceled()) { return MONITOR.done(); }
 println "-- IMPORTER - Reading source files"
 
-if (!(new importer().run(srcDir, binDir, txmDir, encoding, basename, lang))) {
+if (!(new importer().run(srcDir, binDir, txmDir, encoding, basename, lang, project))) {
 	println "import process stopped";
 	return;
 }
@@ -88,7 +88,8 @@
 println "-- ANNOTATE - Running NLP tools"
 boolean annotationSuccess = false;
 if (annotate) {
-	def engine = Toolbox.getEngineManager(EngineType.ANNOTATION).getEngine("TreeTagger")
+	String engineName = project.getImportParameters().node("annotate").get("engine", "TreeTagger")
+	def engine = Toolbox.getEngineManager(EngineType.ANNOTATION).getEngine(engineName)
 	if (engine.processDirectory(txmDir, binDir, ["lang":model])) {
 		annotationSuccess = true;
 		if (project.getCleanAfterBuild()) {
Index: tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/filters/Tokeniser/SimpleTokenizerXml.groovy
===================================================================
--- tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/filters/Tokeniser/SimpleTokenizerXml.groovy	(revision 3054)
+++ tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/filters/Tokeniser/SimpleTokenizerXml.groovy	(revision 3055)
@@ -52,11 +52,14 @@
 import javax.xml.stream.*
 
 import org.txm.importer.PersonalNamespaceContext
+import org.txm.tokenizer.StringTokenizer
+import org.txm.tokenizer.SimpleStringTokenizer
 import org.txm.tokenizer.TokenizerClasses
 
 @CompileStatic
 public class SimpleTokenizerXml {
 	
+	StringTokenizer stringTokenizer;
 	boolean retokenize = false
 	LinkedHashMap<String, String>retokenizedWordProperties = new LinkedHashMap()
 	
@@ -67,18 +70,9 @@
 	/** The intraword_tags. */
 	String intraword_tags = TokenizerClasses.intraword_tags;
 	
-	/** The punct_strong. */
-	String punct_strong = TokenizerClasses.punct_strong;
-	
-	/** The punct_all. */
-	String punct_all = TokenizerClasses.punct_all;
-	
 	/** The word_chars. */
 	String word_chars = TokenizerClasses.word_chars;
 	
-	String fclitics = null; // default behavior don't manage clitics
-	String pclitics = null; // default behavior don't manage clitics
-	
 	/** The outside_text_tags_ignore_content. */
 	String note_content = null;
 	String outside_text_tags_keep_content = null // tag and content NOT removed but not tokenized
@@ -89,12 +83,10 @@
 	Pattern reg_outside_text_tags;
 	Pattern reg_startTag;
 	
-	Pattern reg_punct_other = Pattern.compile("\\p{P}")
-	
 	/** The DEBUG. */
 	public boolean DEBUG = false;
 	
-	/** The outfile. */
+	/** The outfile is the result file. */
 	File outfile;
 	
 	/** The infile. */
@@ -119,16 +111,8 @@
 	String prefix;
 	String filename;
 	
-	def regElision = null;
-	def reg3pts = null;
-	def regPunct;
-	def regFClitics = null ;
-	def regPClitics = null ;
-	String whitespaces;
-	Pattern regWhitespaces;
 	Pattern regLN;
 	Pattern regCTRL;
-	Pattern regSplitWhiteSpaces;
 	
 	public SimpleTokenizerXml(File infile, File outfile) {
 		this(infile, outfile, "");
@@ -142,24 +126,12 @@
 	 */
 	public SimpleTokenizerXml(File infile, File outfile, String lang) {
 		this.lang = lang;
-		if (lang != null)
-			if (lang.startsWith("en")) {
-				fclitics = TokenizerClasses.FClitic_en
-			} else if (lang.startsWith("fr")) {
-				fclitics = TokenizerClasses.FClitic_fr
-				pclitics = TokenizerClasses.PClitic_fr
-			} else if (lang.startsWith("gl")) {
-				fclitics = TokenizerClasses.FClitic_gl
-			} else if (lang.startsWith("it")) {
-				pclitics = TokenizerClasses.PClitic_it
-			}
+		this.stringTokenizer = new SimpleStringTokenizer(lang);
 		
 		word_tags = TokenizerClasses.word_tags;
 		reg_word_tags = Pattern.compile(word_tags);
 		
 		intraword_tags = TokenizerClasses.intraword_tags;
-		punct_strong = TokenizerClasses.punct_strong;
-		punct_all = TokenizerClasses.punct_all;
 		word_chars = TokenizerClasses.word_chars;
 		
 		this.outfile = outfile;
@@ -168,32 +140,20 @@
 		int index = filename.lastIndexOf(".");
 		if (index > 0) filename = filename.substring(0, index);
 		
-		String strRegElision = TokenizerClasses.regElision;
-		if (strRegElision != null && strRegElision.length() > 0)
-			regElision = ~/^([\p{L}-]++${strRegElision}[\p{L}-]++)(.*)$/ // the test must start with the start of string  ^
-		reg3pts = ~/^(.*?)(\.\.\.)(.*)$/
-		
-		String strRegPunct = TokenizerClasses.regPunct;
-		if (strRegPunct != null && strRegPunct.length() > 0)
-			regPunct = ~/^(.*?)($strRegPunct)(.*)$/
-		
-		if (fclitics != null && fclitics.length() > 0)
-			regFClitics = ~/(.+)($fclitics)$/ // the test must end with the end of string $
-		
-		if (pclitics != null && pclitics.length() > 0)
-			regPClitics = /^($pclitics)(.*)/ // the test must start with the start of string  ^
-		
-		if (TokenizerClasses.whitespaces != null && TokenizerClasses.whitespaces.length() > 0)
-			regWhitespaces = ~TokenizerClasses.whitespaces;
-		
-		if (TokenizerClasses.whitespaces != null && TokenizerClasses.whitespaces.length() > 0)
-			regSplitWhiteSpaces = Pattern.compile(TokenizerClasses.whitespaces);
-		
 		regLN = Pattern.compile("/\n/");
 		regCTRL = Pattern.compile("/\\p{C}/");
 	}
 	
 	/**
+	 * Replace the default SimpleStringTokenizer with another
+	 * @param stringTokenizer a StringTokenizer
+	 */
+	public void seStringTokenizer(StringTokenizer stringTokenizer) {
+		if (stringTokenizer == null) return;
+		this.stringTokenizer = stringTokenizer;
+	}
+	
+	/**
 	 * Fill infos.
 	 *
 	 * @param event the event
@@ -545,129 +505,18 @@
 		//if (DEBUG) println "-- chars: "+text+"--";
 		text = regLN.matcher(text).replaceAll(WHITESPACE);
 		text = regCTRL.matcher(text).replaceAll(EMPTY);						// remove ctrl characters
-		if (regSplitWhiteSpaces != null) {
-			for (String s : regSplitWhiteSpaces.split(text)) {		// separate with unicode white spaces
-				//	if (DEBUG){println "process $s"}
-				iterate(s);
-			}
-		} else {
-			iterate(text);
-		}
-	}
-	
-	/**
-	 * Iterate. a String, should be called when a word is found in a String
-	 *
-	 * @param s the s
-	 * @return the java.lang. object
-	 */
-	protected iterate(String s) {
-		while (s != null && s.length() > 0) {
-			//	if (DEBUG){println "  > $s"}
-			s = standardChecks(s);
-		}
-	}
-	
-	/**
-	 * Standard checks.
-	 *
-	 * @param s the s
-	 * @return the java.lang. object
-	 */
-	//	@CompileStatic(SKIP)
-	public String standardChecks(String s) {
-		Matcher m;
-		if (fclitics != null && (m = s =~ regFClitics) ) {
-			//	if (DEBUG) println "CLITIC found: $s ->"+ m
-			iterate(m.group(1))
-			
+
+				def words = stringTokenizer.processText(text);
+		for (def word : words) {
 			wordcount++;
 			writer.writeStartElement(word_element_to_create);
 			writeWordAttributes();// id
-			//writer.writeAttribute("type", "w");
-			writer.writeCharacters(m.group(2));
+			writer.writeCharacters(word);
 			writer.writeEndElement();
 			writer.writeCharacters("\n");
-			
-			return "";
-		} else if (pclitics != null && (m = s =~ regPClitics) ) {
-			if (DEBUG) println "PCLITIC found: $s ->"+ m
-			
-			wordcount++;
-			writer.writeStartElement(word_element_to_create);
-			writeWordAttributes();// id
-			//writer.writeAttribute("type", "w");
-			writer.writeCharacters(m.group(1));
-			writer.writeEndElement();
-			writer.writeCharacters("\n");
-			
-			iterate(m.group(2))
-			
-			return "";
-		} else if (regElision != null && (m = s =~ regElision) ) {
-			//	if (DEBUG) println "Elision found: $s ->"+ m.group(1)+" + "+m.group(2)+" + "+m.group(3)
-			//iterate(m.group(1))
-			
-			//			int sep = s.indexOf("'");
-			//			if (sep < 0)
-			//				sep = s.indexOf("’");
-			//			if (sep < 0)
-			//				sep = s.indexOf("‘");
-			
-			wordcount++;
-			writer.writeStartElement(word_element_to_create);
-			writeWordAttributes();// id
-			//writer.writeAttribute("type", "w");
-			writer.writeCharacters(m.group(1));
-			writer.writeEndElement();
-			writer.writeCharacters("\n");
-			
-			iterate(m.group(2))
-			
-			return "";
-		} else if (reg3pts != null && (m = s =~ reg3pts) )	{
-			//	if(DEBUG){println "REG '...' found: $s -> "+m.group(1)+" + "+m.group(2)+" + "+m.group(3)}
-			iterate(m.group(1))
-			
-			wordcount++;
-			writer.writeStartElement(word_element_to_create);
-			writeWordAttributes();// id
-			//writer.writeAttribute("type","pon");
-			writer.writeCharacters("...");
-			writer.writeEndElement();
-			writer.writeCharacters("\n");
-			
-			return m.group(3);
-		} else if (regPunct != null && (m = s =~ regPunct) ) {
-			if(DEBUG){println "PUNCT found: $s ->"+m.group(1)+" + "+m.group(2)+" + "+m.group(3)}
-			iterate(m.group(1));
-			
-			wordcount++;
-			writer.writeStartElement(word_element_to_create);
-			writeWordAttributes();// id
-			//writer.writeAttribute("type","pon");
-			writer.writeCharacters(m.group(2));
-			writer.writeEndElement();
-			writer.writeCharacters("\n");
-			
-			return m.group(3);
-		} else {
-			//		if(DEBUG){println "Other found: "+s}
-			wordcount++;
-			writer.writeStartElement(word_element_to_create);
-			writeWordAttributes();// id
-			//			if (reg_punct_other.matcher(s).matches())
-			//				writer.writeAttribute("type","pon");
-			//			else
-			//				writer.writeAttribute("type","w");
-			writer.writeCharacters(s);
-			writer.writeEndElement();
-			writer.writeCharacters("\n");
-			
-			return "";
 		}
 	}
-	
+
 	/**
 	 * Write word attributes.
 	 *
@@ -783,13 +632,16 @@
 		//		println "Done"
 		
 		String lang = "fr"
-		File inFile = new File(System.getProperty("user.home"), "xml/vocapia/test.trs")
-		File outFile = new File(System.getProperty("user.home"), "xml/vocapia/test-retokenized.trs")
+		File inFile = new File(System.getProperty("user.home"), "SVN/TXMSVN/trunk/corpora/tokenizer/test1.xml")
+		File outFile = new File(System.getProperty("user.home"), "SVN/TXMSVN/trunk/corpora/tokenizer/test1-tmp.xml")
 		
 		println "processing "+inFile
 		
 		SimpleTokenizerXml tokenizer = new SimpleTokenizerXml(inFile, outFile, lang)
-		tokenizer.setRetokenize(true)
+		tokenizer.setRetokenize(false)
+		tokenizer.setNote("note")
+		//tokenizer.setOutSideTextTags("outsideToEdit")
+		tokenizer.setOutSideTextTagsAndKeepContent("outsideToEdit")
 		//tokenizer.setDEBUG false
 		tokenizer.process();
 		
Index: tmp/org.txm.groovy.core/src/groovy/org/txm/macro/prototypes/ApplyXQueryMacro.groovy
===================================================================
--- tmp/org.txm.groovy.core/src/groovy/org/txm/macro/prototypes/ApplyXQueryMacro.groovy	(revision 3054)
+++ tmp/org.txm.groovy.core/src/groovy/org/txm/macro/prototypes/ApplyXQueryMacro.groovy	(revision 3055)
@@ -53,7 +53,7 @@
 	return false;
 }
 
-def xmlFiles = txmDir.listFiles();
+def xmlFiles = txmDir.listFiles().sort{ it.name };
 if (xmlFiles == null || xmlFiles.size() == 0) {
 	println "Error: no file found in $txmDir"
 	return false;
Index: tmp/org.txm.groovy.core/src/groovy/org/txm/macro/prototypes/file/DirectoryInfoMacro.groovy
===================================================================
--- tmp/org.txm.groovy.core/src/groovy/org/txm/macro/prototypes/file/DirectoryInfoMacro.groovy	(revision 3054)
+++ tmp/org.txm.groovy.core/src/groovy/org/txm/macro/prototypes/file/DirectoryInfoMacro.groovy	(revision 3055)
@@ -29,7 +29,7 @@
 println " write? "+directory.canWrite()
 println " executable? "+directory.canExecute()
 println " hidden? "+directory.isHidden()
-def files = directory.listFiles()
+def files = directory.listFiles().sort{ it.name }
 println " number of files? "+files.size()
 
 
Index: tmp/org.txm.groovy.core/src/groovy/org/txm/macro/prototypes/FindMultiLineRegExpMacro.groovy
===================================================================
--- tmp/org.txm.groovy.core/src/groovy/org/txm/macro/prototypes/FindMultiLineRegExpMacro.groovy	(revision 3054)
+++ tmp/org.txm.groovy.core/src/groovy/org/txm/macro/prototypes/FindMultiLineRegExpMacro.groovy	(revision 3055)
@@ -66,7 +66,7 @@
 
 println "-- looking for: $regexp"
 
-for (File inputfile : inputDirectory.listFiles()) {
+for (File inputfile : inputDirectory.listFiles().sort{ it.name }) {
 
 	if (inputfile.isDirectory()) continue // ignore
 
Index: tmp/org.txm.groovy.core/src/groovy/org/txm/macro/prototypes/GetXPathMacro.groovy
===================================================================
--- tmp/org.txm.groovy.core/src/groovy/org/txm/macro/prototypes/GetXPathMacro.groovy	(revision 3054)
+++ tmp/org.txm.groovy.core/src/groovy/org/txm/macro/prototypes/GetXPathMacro.groovy	(revision 3055)
@@ -53,7 +53,7 @@
 
 if (srcDirectory!=null && srcDirectory.exists()) {
 
-	def files = srcDirectory.listFiles()
+	def files = srcDirectory.listFiles().sort{ it.name }
 	if (files == null || files.size() == 0) {
 		println "No files in $srcDirectory"
 		return;
Index: tmp/org.txm.groovy.core/src/groovy/org/txm/macro/prototypes/xml/XSL2CQPMacro.groovy
===================================================================
--- tmp/org.txm.groovy.core/src/groovy/org/txm/macro/prototypes/xml/XSL2CQPMacro.groovy	(revision 3054)
+++ tmp/org.txm.groovy.core/src/groovy/org/txm/macro/prototypes/xml/XSL2CQPMacro.groovy	(revision 3055)
@@ -42,7 +42,7 @@
 	return false;
 }
 
-def xmlFiles = txmDir.listFiles();
+def xmlFiles = txmDir.listFiles().sort{ it.name };
 if (xmlFiles == null || xmlFiles.size() == 0) {
 	println "Error: no file found in $txmDir"
 	return false;
Index: tmp/org.txm.groovy.core/src/groovy/org/txm/macro/prototypes/xml/ApplyXQueryMacro.groovy
===================================================================
--- tmp/org.txm.groovy.core/src/groovy/org/txm/macro/prototypes/xml/ApplyXQueryMacro.groovy	(revision 3054)
+++ tmp/org.txm.groovy.core/src/groovy/org/txm/macro/prototypes/xml/ApplyXQueryMacro.groovy	(revision 3055)
@@ -53,7 +53,7 @@
 	return false;
 }
 
-def xmlFiles = txmDir.listFiles();
+def xmlFiles = txmDir.listFiles().sort{ it.name };
 if (xmlFiles == null || xmlFiles.size() == 0) {
 	println "Error: no file found in $txmDir"
 	return false;
Index: tmp/org.txm.groovy.core/src/groovy/org/txm/macro/nlp/TT2XMLInDirectoryMacro.groovy
===================================================================
--- tmp/org.txm.groovy.core/src/groovy/org/txm/macro/nlp/TT2XMLInDirectoryMacro.groovy	(revision 3054)
+++ tmp/org.txm.groovy.core/src/groovy/org/txm/macro/nlp/TT2XMLInDirectoryMacro.groovy	(revision 3055)
@@ -26,7 +26,7 @@
 	
 	XMLOutputFactory factory = XMLOutputFactory.newInstance()
 	
-	def files = inputDirectory.listFiles()
+	def files = inputDirectory.listFiles().sort{ it.name }
 	if (files == null || files.length == 0) {
 		println "Error: no file to process in $inputDirectory"
 		return false;
Index: tmp/org.txm.groovy.core/src/groovy/org/txm/macro/projects/antract/FixINATRSMacro.groovy
===================================================================
--- tmp/org.txm.groovy.core/src/groovy/org/txm/macro/projects/antract/FixINATRSMacro.groovy	(revision 3054)
+++ tmp/org.txm.groovy.core/src/groovy/org/txm/macro/projects/antract/FixINATRSMacro.groovy	(revision 3055)
@@ -14,7 +14,7 @@
 if (!ParametersDialog.open(this)) return;
 
 println "Fixing $trsDirectory"
-def files = trsDirectory.listFiles()
+def files = trsDirectory.listFiles().sort{ it.name }
 if (files == null) {
 	println "No files found in $trsDirectory"
 	return 0;
Index: tmp/org.txm.groovy.core/src/groovy/org/txm/macro/imports/TeiHeader2MetadataCSVMacro.groovy
===================================================================
--- tmp/org.txm.groovy.core/src/groovy/org/txm/macro/imports/TeiHeader2MetadataCSVMacro.groovy	(revision 3054)
+++ tmp/org.txm.groovy.core/src/groovy/org/txm/macro/imports/TeiHeader2MetadataCSVMacro.groovy	(revision 3055)
@@ -39,7 +39,7 @@
 	return
 }
 
-List<File> files = inputDirectory.listFiles()
+List<File> files = inputDirectory.listFiles().sort{ it.name }
 if (files == null || files.size() == 0) {
 	println "** TeiHeader2MetadataCSV: no files found in '$inputDirectory' directory."
 	return
Index: tmp/org.txm.groovy.core/src/groovy/org/txm/macro/xml/CombineAttributesMacro.groovy
===================================================================
--- tmp/org.txm.groovy.core/src/groovy/org/txm/macro/xml/CombineAttributesMacro.groovy	(revision 0)
+++ tmp/org.txm.groovy.core/src/groovy/org/txm/macro/xml/CombineAttributesMacro.groovy	(revision 3055)
@@ -0,0 +1,59 @@
+// STANDARD DECLARATIONS
+package org.txm.macro.xml
+
+import org.txm.annotation.kr.core.conversion.*
+import javax.xml.stream.XMLStreamReader
+import java.io.File;
+import java.io.IOException;
+import java.util.HashSet;
+import java.util.LinkedHashMap;
+import java.util.regex.Pattern;
+
+@Field @Option(name="xmlFile", usage="fichier XML lu", widget="FileOpen", required=true, def="in.xml") // /home/mdecorde/TEMP/ANTRACT/AF/all.xlsx
+File xmlFile
+
+@Field @Option(name="resultFile", usage="fichier XML resultat", widget="FileSave", required=true, def="out.xml") // /home/mdecorde/TEMP/ANTRACT/AF/all.xlsx
+File resultFile
+
+@Field @Option(name = "elementName", usage = "oldType", widget = "String", required = true, def = "w")
+String elementName
+
+//@Field @Option(name = "oldType", usage = "oldType", widget = "String", required = true, def = "myattr")
+def oldType = null // not needed
+	
+@Field @Option(name = "newType", usage = "newType", widget = "String", required = true, def = "myattr")
+String newType
+
+@Field @Option(name = "separator", usage = "newType", widget = "Separator", required = false, def = "Code")
+def separator
+
+@Field @Option(name = "getValueCode", usage = "code of the getValue(XMLStreamReader parser, String localname, String attribute, String value) method", widget = "Text", required = true, def = "\"NEWGROOVE\" + parser.getAttributeValue(null, \"myattr\") ")
+String getValueCode
+
+@Field @Option(name = "additionalImportsCode", usage = "code of the getValue(XMLStreamReader parser, String localname, String attribute, String value) method", widget = "Text", required = true, def = "import java.io.File")
+String additionalImportsCode
+
+@Field @Option(name = "debug", usage = "show debug messages", widget = "Boolean", required = true, def = "false")
+boolean debug
+
+if (!ParametersDialog.open(this)) return;
+
+
+// not needed
+LinkedHashMap<Pattern, String> rules = new LinkedHashMap<>();
+
+XMLTXMFileRuledConversion converter = new XMLTXMFileRuledConversion(xmlFile, rules, elementName, oldType, newType, XMLTXMFileRuledConversion.ABANDON);
+
+// initialize a converter using getValueCode value to fill the getValue(parser, localname, attribute, value) method
+converter.converter = gse.evaluate("""import org.txm.annotation.kr.core.conversion.*;
+import javax.xml.stream.XMLStreamReader
+$additionalImportsCode
+
+return new XMLTXMFileRuledConversion.Converter() {
+	public String getValue(XMLStreamReader parser, String localname, String attribute, String value) {
+		$getValueCode
+	}
+};
+""");
+converter.debug = debug
+converter.process(resultFile)
\ No newline at end of file
Index: tmp/org.txm.groovy.core/src/groovy/org/txm/macro/annotation/InjectWordPropTableMacro.groovy
===================================================================
--- tmp/org.txm.groovy.core/src/groovy/org/txm/macro/annotation/InjectWordPropTableMacro.groovy	(revision 3054)
+++ tmp/org.txm.groovy.core/src/groovy/org/txm/macro/annotation/InjectWordPropTableMacro.groovy	(revision 3055)
@@ -81,7 +81,7 @@
 
 println "Injecting..."
 //for (String textid : injections.keySet()) {
-for (File currentXMLFile : inputDirectory.listFiles()) {
+for (File currentXMLFile : inputDirectory.listFiles().sort{ it.name }) {
 	if (currentXMLFile.isDirectory()) continue;
 	if (currentXMLFile.isHidden()) continue;
 	
Index: tmp/org.txm.groovy.core/src/java/org/txm/groovy/core/GSERunner.java
===================================================================
--- tmp/org.txm.groovy.core/src/java/org/txm/groovy/core/GSERunner.java	(revision 3054)
+++ tmp/org.txm.groovy.core/src/java/org/txm/groovy/core/GSERunner.java	(revision 3055)
@@ -22,6 +22,7 @@
 
 import cern.colt.Arrays;
 import groovy.lang.Binding;
+import groovy.lang.GroovyShell;
 import groovy.util.GroovyScriptEngine;
 import groovy.util.ResourceException;
 import groovy.util.ScriptException;
@@ -128,6 +129,10 @@
 		return defaultGSE;
 	}
 	
+	public Object evaluate(String code) {
+		return new GroovyShell(this.getGroovyClassLoader(), new Binding()).evaluate(code);
+	}
+	
 	public static void getDependancies(String bundle, HashSet<String> defaultPlugins) {
 		// if (defaultPlugins.contains(bundle)) return;
 		
Index: tmp/org.txm.groovy.core/META-INF/MANIFEST.MF
===================================================================
--- tmp/org.txm.groovy.core/META-INF/MANIFEST.MF	(revision 3054)
+++ tmp/org.txm.groovy.core/META-INF/MANIFEST.MF	(revision 3055)
@@ -4,10 +4,11 @@
 Bundle-Version: 1.0.0.qualifier
 Bundle-Name: Macro
 Bundle-ClassPath: .,bin/
-Require-Bundle: org.txm.core;bundle-version="0.8.0";visibility:=reexpo
- rt,org.txm.annotation.core;visibility:=reexport,org.txm.searchengine.
- cqp.core;visibility:=reexport,org.txm.tokenizer.core;visibility:=reex
- port,org.eclipse.osgi
+Require-Bundle: org.txm.core;bundle-version="0.8.0";visibility:=reexport,
+ org.txm.annotation.core;visibility:=reexport,
+ org.txm.searchengine.cqp.core;visibility:=reexport,
+ org.txm.tokenizer.core;visibility:=reexport,
+ org.eclipse.osgi;visibility:=reexport
 Bundle-ActivationPolicy: lazy
 Bundle-ManifestVersion: 2
 Bundle-RequiredExecutionEnvironment: JavaSE-1.8
Index: tmp/org.txm.ocaml.core/META-INF/MANIFEST.MF
===================================================================
--- tmp/org.txm.ocaml.core/META-INF/MANIFEST.MF	(revision 3054)
+++ tmp/org.txm.ocaml.core/META-INF/MANIFEST.MF	(revision 3055)
@@ -20,7 +20,8 @@
 Bundle-Name: Ocaml
 Bundle-Version: 2.0
 Bundle-ClassPath: .,lib/ocamlrun-scripting.jar,lib/ocaml-lib-files.jar
-Require-Bundle: org.txm.core,org.eclipse.core.runtime
+Require-Bundle: org.txm.core;visibility:=reexport,
+ org.eclipse.core.runtime;visibility:=reexport
 Bundle-ManifestVersion: 2
 Bundle-RequiredExecutionEnvironment: JavaSE-1.8
 Bundle-Vendor: Textometrie.org
Index: tmp/org.txm.practically.rcp/META-INF/MANIFEST.MF
===================================================================
--- tmp/org.txm.practically.rcp/META-INF/MANIFEST.MF	(revision 3054)
+++ tmp/org.txm.practically.rcp/META-INF/MANIFEST.MF	(revision 3055)
@@ -2,7 +2,7 @@
 Export-Package: practicallymacro.actions,practicallymacro.commands,pra
  cticallymacro.dialogs,practicallymacro.editormacros,practicallymacro.
  model,practicallymacro.preferences,practicallymacro.util
-Bundle-SymbolicName: org.txm.pratically.rcp;singleton:=true
+Bundle-SymbolicName: org.txm.practically.rcp;singleton:=true
 Bundle-Version: 0.4.5
 Bundle-Name: PracticallyMacro Plug-in
 Require-Bundle: org.eclipse.ui;visibility:=reexport,org.eclipse.core.r
Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/StructuralUnitProperty.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/StructuralUnitProperty.java	(revision 3054)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/StructuralUnitProperty.java	(revision 3055)
@@ -39,6 +39,7 @@
 import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
 import org.txm.searchengine.cqp.clientExceptions.UnexpectedAnswerException;
 import org.txm.searchengine.cqp.corpus.query.CQLQuery;
+import org.txm.searchengine.cqp.corpus.query.MatchUtils;
 import org.txm.searchengine.cqp.serverException.CqiServerError;
 import org.txm.utils.logger.Log;
 
@@ -301,14 +302,39 @@
 		
 		return null;
 	}
-
+	
 	public String cpos2Str(int position) throws UnexpectedAnswerException, IOException, CqiServerError {
 		AbstractCqiClient cqiClient = CorpusManager.getCorpusManager().getCqiClient();
-		return cqiClient.getSingleData(this, new int[] {position}).get(0);
+		return cqiClient.getSingleData(this, new int[] { position }).get(0);
 	}
 	
 	public String[] cpos2Str(int[] positions) throws UnexpectedAnswerException, IOException, CqiServerError {
 		AbstractCqiClient cqiClient = CorpusManager.getCorpusManager().getCqiClient();
 		return cqiClient.getSingleData(this, positions).toArray(new String[positions.length]);
 	}
+	
+	/**
+	 * Very slow
+	 * 
+	 * @return
+	 * @throws IOException
+	 * @throws CqiServerError
+	 * @throws CqiClientException
+	 */
+	public int getNValues() throws IOException, CqiServerError, CqiClientException {
+		return getValues().size();
+	}
+	
+	/**
+	 * Very slow
+	 * 
+	 * @return
+	 * @throws IOException
+	 * @throws CqiServerError
+	 * @throws CqiClientException
+	 */
+	public String[] getValuesAsStrings() throws IOException, CqiServerError, CqiClientException {
+		List<String> values = getValues();
+		return values.toArray(new String[values.size()]);
+	}
 }
Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/CQPCorpus.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/CQPCorpus.java	(revision 3054)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/CQPCorpus.java	(revision 3055)
@@ -1484,4 +1484,21 @@
 		
 		return null;
 	}
+	
+	/**
+	 * parse a "struct_prop" property name to find the matching StructuralUnitProperty
+	 * 
+	 * @param p
+	 * @return
+	 */
+	public StructuralUnitProperty getStructuralUnitProperty(String p) {
+		
+		try {
+			return StructuralUnitProperty.stringToStructuralUnitProperty(this, p);
+		}
+		catch (CqiClientException e) {
+			e.printStackTrace();
+			return null;
+		}
+	}
 }
